DrumMachineRow {
	var buttons, multi, randbutt1, randbutt2, clearbutt, resetbutt, <volslid, <offsetslid; 
	var <blastval,<multilastval;

	*new { arg w, x, y, n; 
		^super.new.initGUI(w,x,y,n);
	}
	
	initGUI { arg w, x, y, n; 
		
		buttons = Array.fill(n);
		blastval= Array.fill(n,0);
	
		n.do({ arg i;
			buttons.put(i,SCButton(w, Rect(x+(i*20), y+2.5, 15, 15)));
			buttons.at(i).states = [
				["", Color.white, Color.red],
				["x", Color.white, Color.red]
			];
			//when button pressed update the data variable
			buttons.at(i).action_({blastval.put(i,buttons.at(i).value);});	
		});
		
		multi= SCMultiSliderView(w, Rect(x,y+25, n*20, 20));
		multilastval = Array.fill(n,1.0);
		multi.value_(multilastval);//starting values
		multi.valueThumbSize_(1.0);	//1 pixel y size
		multi.indexThumbSize_(15.0);//15 pixels x size
		multi.gap_(5);
		
		multi.background_(Color.new255(127, 255, 212));
		multi.strokeColor_(Color.new255(138, 43, 226));
		multi.action_({ multilastval= multi.value });
		
		randbutt1= SCButton(w, Rect(x+(n*20), y, 30, 25));
		randbutt1.states = [["rand", Color.white, Color.blue]];
		randbutt1.action_({
			blastval.do({ arg val, i; blastval.put(i,2.rand)}); 
			buttons.do({ arg val,i; val.value_(blastval.at(i))});
		});
		
		randbutt2= SCButton(w, Rect(x+(n*20), y+25, 30, 25));
		randbutt2.states = [["rand", Color.white, Color.blue]];
		randbutt2.action_({
			multilastval= Array.fill(blastval.size,{exprand(0.01,1.0)});
			multi.value_(multilastval);
		});
		
		clearbutt= SCButton(w, Rect(x+(n*20)+30, y, 30, 25));
		clearbutt.states = [["clear", Color.white, Color.blue]];
		clearbutt.action_({
			blastval.do({ arg val, i; blastval.put(i,0)}); 
			buttons.do({ arg val,i; val.value_(blastval.at(i))});
		});
		
		resetbutt= SCButton(w, Rect(x+(n*20)+30, y+25, 30, 25));
		resetbutt.states = [["reset", Color.white, Color.blue]];
		resetbutt.action_({
			multilastval= Array.fill(blastval.size,{1.0});
			multi.value_(multilastval);
		});
		
		volslid= DDSlider(w, Rect(x+(n*20)+60,y,100,25), "volume", 0.0, 1.0, 'amp', 0.0, 0.5);
		offsetslid= DDSlider(w, Rect(x+(n*20)+60,y+25,100,25), "offset", 0,n-1, 'lin', 1, 0);
		
	}
	
	getpos { arg counter;
		^(counter+(offsetslid.value.round(1.0).asInteger)%(blastval.size))
	}
	
	strike { arg pos;
		// defer is used because UIs can't be directly 
		// manipulated from a SystemClock like TempoClock
		{
			// set current button to show we are here!
			buttons.at(pos).states_([
				["", Color.white, Color.blue],
				["X", Color.white, Color.blue]
			]);
			buttons.at(pos).refresh;
	
			// schedule turn off too
			{
				buttons.at(pos).states_([
					["", Color.white, Color.red],
					["x", Color.white, Color.red]
				]);
				buttons.at(pos).refresh;
			}.defer(0.02);
	
		}.defer;
	
	}



}